//+------------------------------------------------------------------+
//|                                               FINAL MOMENTUM.mq4 |
//|                                                            Anton |
//|                                                                  |
//+------------------------------------------------------------------+

#property strict

// External variables

extern double StopLoss = 18;
extern double TakeProfit = 18;
extern double MinimumMA15 = 0.047;
extern double MinimumMA1 = 0.018;
extern int MagicNumber = 23310;
input double TrailingStop  = 9;

extern double VolEntry = 0.0013;
extern int STDper = 6;

// Global variables
int LongTicket;               
int ShortTicket;              

//------------------------------------------------------------  
//------------------------------------------------------------
   
// Start function

void OnTick()	
	
//------------------------------------------------------------  
//------------------------------------------------------------
//Only one trade allowed per pair at a time
//------------------------------------------------------------  
//------------------------------------------------------------	
	{  
   int total,ord,i;
   string symbol;
   total = OrdersTotal();
   
   for(i=0;i<total;i++)

   {
   OrderSelect(i,SELECT_BY_POS);
   if(OrderSymbol() == Symbol())ord++;
   }
   
   if(ord>0) return; 
//------------------------------------------------------------  
//------------------------------------------------------------	

double AccountBalance = AccountInfoDouble(ACCOUNT_BALANCE);
double Leverage = AccountInfoInteger(ACCOUNT_LEVERAGE);
double LotSize = (((((AccountBalance/Ask)*Leverage) - 1)/100000));

double MA1L15 = iMA(NULL,15,7,0,MODE_EMA,0,0);
double MA2L15 = iMA(NULL,15,21,0,MODE_EMA,0,0);
 
double MA1L5 = iMA(NULL,5,7,0,MODE_EMA,0,0);
double MA2L5 = iMA(NULL,5,21,0,MODE_EMA,0,0); 

double MA1L1 = iMA(NULL,1,7,0,MODE_EMA,0,0);
double MA2L1 = iMA(NULL,1,21,0,MODE_EMA,0,0);

double STDDEV = iStdDev(NULL,60,STDper,0,MODE_EMA,PRICE_CLOSE,0); 

//LONG 	 
//------------------------------------------------------------  
//BUY CONDITION 1 -->Count of Bids/Asks
//------------------------------------------------------------  

   static int    countL   = 0;
   static double lastBid = 0;

   if(Bid > lastBid) { countL++;   }
   else              { countL = 0; }   
   lastBid = Bid;

   bool buy_condition_1 = (countL >= 5);
   
//------------------------------------------------------------  
//BUY CONDITION 2 -->Moving Average 15min
//------------------------------------------------------------  
	
	bool buy_condition_2 = (MA1L15 > MA2L15);
	
//------------------------------------------------------------  
//BUY CONDITION 3 -->Moving Average 5min
//------------------------------------------------------------  
	
	bool buy_condition_3 = (MA1L5 > MA2L5);	
	
//------------------------------------------------------------  
//BUY CONDITION 4 -->Moving Average 1min
//------------------------------------------------------------  
	
	bool buy_condition_4 = (MA1L1 > MA2L1);		
	
//------------------------------------------------------------ 
//BUY CONDITION 5 --> Minimum Moving Average 15min
//------------------------------------------------------------
   
   bool buy_condition_5 = ((((MA1L15/MA2L15)-1)*100)>MinimumMA15); 
   
//------------------------------------------------------------ 
//BUY CONDITION 6 --> Minimum Moving Average 1min
//------------------------------------------------------------
   
   bool buy_condition_6 = ((((MA1L1/MA2L1)-1)*100)>MinimumMA1); 
       
//------------------------------------------------------------ 
//BUY CONDITION 7 --> Standard Deviation 60min
//------------------------------------------------------------
   
   bool buy_condition_7 = (STDDEV > VolEntry);  	 	
	
//************************************************************ 
//EXECUTE BUY ORDER	
//************************************************************ 		
		      
		      {                              
		      if( buy_condition_1 && buy_condition_2 && buy_condition_3 && buy_condition_4 && buy_condition_5 && buy_condition_6 && buy_condition_7)
		 	   {
				     
				double LongStopLoss = Ask - (StopLoss * Point*10);
            double LongTakeProfit = Ask + (TakeProfit * Point*10);
				     			     
		//------------------------------------------------------------------------------------------------------------------- 	
      //------------------------------------------------------------------------------------------------------------------- 
		LongTicket = OrderSend(Symbol(),OP_BUY,LotSize,Ask,0,LongStopLoss,LongTakeProfit,"Buy Order",MagicNumber,0,Green);
	   //------------------------------------------------------------------------------------------------------------------- 	
      //------------------------------------------------------------------------------------------------------------------- 		
			
			   double LongOpen = OrderOpenPrice();

				OrderSelect(LongTicket,SELECT_BY_TICKET);
			   RefreshRates();
	   
			   if((Bid-LongOpen)*10000>TrailingStop)
           
            { 
 
              Print("Trailing Stop ",TrailingStop);
              Print("Bid - LongOpen ",Bid-LongOpen);
              
              bool res=OrderModify(LongTicket,OrderOpenPrice(),(Bid-(Point*TrailingStop*10)),OrderTakeProfit(),0,Blue); 
              
              if(!res) 
                    Print("Error in OrderModify. Error code=",GetLastError()); 
              else 
                    Print("Order modified successfully.");
            }	      
		      
		      }
		      }		
//**************************************************************	                                       
  
  // SHORT
  //----------------------------------------------------------  
  //SELL CONDITION 1 -->Count of Bids/Asks
  //----------------------------------------------------------
   
   static int    countS   = 0;
   static double lastAsk = 0;

   if(Ask < lastAsk) { countS++;   }
   else              { countS = 0; }   
   lastAsk = Ask;
   
   bool sell_condition_1 = (countS >= 5);
     
  //---------------------------------------------------------- 
  //SELL CONDITION 2 -->Moving Average 15min
  //----------------------------------------------------------
   
   bool sell_condition_2 = (MA1L15 < MA2L15);

  //----------------------------------------------------------
  //SELL CONDITION 3 -->Moving Average 5min
  //---------------------------------------------------------- 
   
   bool sell_condition_3 = (MA1L5 < MA2L5);
   
  //----------------------------------------------------------
  //SELL CONDITION 4 -->Moving Average 1min
  //---------------------------------------------------------- 
   
   bool sell_condition_4 = (MA1L1 < MA2L1);
   
  //----------------------------------------------------------
  //SELL CONDITION 5 --> Minimum Moving Average 15min
  //----------------------------------------------------------  
   
   bool sell_condition_5 = ((((MA2L15/MA1L15)-1)*100)>MinimumMA15);  
  
  //----------------------------------------------------------
  //SELL CONDITION 6 --> Minimum Moving Average 1min
  //----------------------------------------------------------  
   
   bool sell_condition_6 = ((((MA2L1/MA1L1)-1)*100)>MinimumMA1);  
   
  //------------------------------------------------------------ 
  //SELL CONDITION 7 --> Standard Deviation 60min
  //------------------------------------------------------------
   
   bool sell_condition_7 = (STDDEV > VolEntry);  
   
//************************************************************ 	
//EXECUTE SELL CONDITION
//************************************************************
		     
		      {                              
		      if( sell_condition_1 && sell_condition_2 && sell_condition_3 && sell_condition_4 && sell_condition_5 && sell_condition_6 && sell_condition_7)
			   { 
        
            double ShortStopLoss =  Bid + (StopLoss * Point*10);
            double ShortTakeProfit = Bid - (TakeProfit * Point*10);
             			      
		//------------------------------------------------------------------------------------------------------------------- 	
      //-------------------------------------------------------------------------------------------------------------------
      ShortTicket = OrderSend(Symbol(),OP_SELL,LotSize,Bid,0,ShortStopLoss,ShortTakeProfit,"Sell Order",MagicNumber,0,Red); 
	   //------------------------------------------------------------------------------------------------------------------- 	
      //-------------------------------------------------------------------------------------------------------------------  		
			   
			   double ShortOpen = OrderOpenPrice();
			   
			   OrderSelect(ShortTicket,SELECT_BY_TICKET);
			   RefreshRates();
			   if((ShortOpen-Ask)*10000>TrailingStop)
            
            { 
              bool res=OrderModify(ShortTicket,OrderOpenPrice(),(Ask+(Point*TrailingStop*10)),OrderTakeProfit(),0,Blue);
              if(!res) 
                    Print("Error in OrderModify. Error code=",GetLastError()); 
              else 
                    Print("Order modified successfully.");
            }
		      
		      }
		      }	
//**************************************************************		      	

}





















                 
